Codeforces 102394I Interesting Permutation (脑洞)

2024-03-20 12:32

本文主要是介绍Codeforces 102394I Interesting Permutation (脑洞),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

I. Interesting Permutation


time limit per test 1 second
memory limit per test 512 megabytes

DreamGrid has an interesting permutation of 1,2,…,n denoted by a1,a2,…,an. He generates three sequences f, g and h, all of length n, according to the permutation a in the way described below:

For each 1≤i≤n, fi=max{a1,a2,…,ai};
For each 1≤i≤n, gi=min{a1,a2,…,ai};
For each 1≤i≤n, hi=fi−gi.
BaoBao has just found the sequence h DreamGrid generates and decides to restore the original permutation. Given the sequence h, please help BaoBao calculate the number of different permutations that can generate the sequence h. As the answer may be quite large, print the answer modulo 10^9+7.

Input
The input contains multiple cases. The first line of the input contains a single integer T (1≤T≤20000), the number of cases.

For each case, the first line of the input contains a single integer n (1≤n≤10^5), the length of the permutation as well as the sequences. The second line contains n integers h1,h2,…,hn (1≤i≤n,0≤hi≤10^9).

It's guaranteed that the sum of n over all cases does not exceed 2*10^6.

Output
For each case, print a single line containing a single integer, the number of different permutations that can generate the given sequence h. Don't forget to print the answer modulo 10^9+7.

Example
input
3
3
0 2 2
3
0 1 2
3
0 2 3
output
2
4
0
Note
For the first sample case, permutations {1,3,2} and {3,1,2} can both generate the given sequence.

For the second sample case, permutations {1,2,3}, {2,1,3}, {2,3,1} and {3,2,1} can generate the given sequence.

题目链接:http://codeforces.com/gym/102394/problem/I

题目大意:定义原排列P为a1,a2,...,an,fi=max{a1,a2,…,ai},gi=min{a1,a2,…,ai},hi=fi−gi,现给出序列h,求满足h的P的个数

题目分析:可以先特判掉3个显然非法的情况:h[0] != 0;h中存在降序;h中存在大于等于n的值

对剩下的情况,考虑h[i]和h[i - 1]的大小,其中若h[i] > h[i - 1],此时要么最大值有更新要么最小值有更新,故将方案数乘2,若h[i]==h[i - 1],则对于第i个数,它必然是1~i中介于最大和最小之间的数,我们称之为中间数,假设中间数有num个,我们要做的就是把答案乘上num,现在问题就是怎么求得num,其实当h[i] > h[i - 1]时,它们的差值(h[i] - h[i - 1] - 1)就是加上h[i]后新增的中间数的个数,减1是因为要将h[i]自身除去

#include <cstdio>
#define ll long long
using namespace std;
int const MAX = 1e5 + 5;
int const MOD = 1e9 + 7;
int n, T, h[MAX];int main() {scanf("%d", &T);while (T--) {bool ok = true;scanf("%d", &n);for (int i = 0; i < n; i++) {scanf("%d", &h[i]);}ok = h[0] == 0;for (int i = 1; ok && i < n; i++) {if (h[i] >= n) {ok = false;}if (h[i] < h[i - 1]) {ok = false;}}if (!ok) {printf("0\n");continue;}ll ans = 1, num = 0;for (int i = 1; i < n; i++) {if (h[i] > h[i - 1]) {ans = (ans << 1) % MOD;num += h[i] - h[i - 1] - 1;} else {ans = (ans * num) % MOD;num--;}}printf("%lld\n", ans);}
}

 

这篇关于Codeforces 102394I Interesting Permutation (脑洞)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/829457

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

Codeforces#295(Div.2)A、B(模拟+BFS)

解题报告链接:点击打开链接 C. 题目链接:点击打开链接 解题思路: 对于给定的字符串,取出现次数最多的字母(可以同时有多个)。由这些字母组成长度为n的字符串,求有多少种组合。最后用数学知识即可。 完整代码: #include <algorithm>#include <iostream>#include <cstring>#include <climits>

Codeforces Round #281 (Div. 2)A(构造+暴力模拟)

题目链接:http://codeforces.com/problemset/problem/493/A 解题思路: 暴力的判断,分三种情况去判断即可。注意如果之前已经被罚下场后,那么在后面的罚下情况不应该算在输出结果内。 完整代码: #include <algorithm>#include <iostream>#include <cstring>#include <co

Codeforces Round #182 (Div. 2)A(水题)

题目链接:http://codeforces.com/contest/302/problem/A 解题思路: 只要通过重新排列使区间内和为0即是1,否则是0. 完整代码: #include <algorithm>#include <iostream>#include <cstring>#include <complex>#include <cstdio>#inc

Codeforces Round #233 (Div. 2)A(构造)

题目链接:http://codeforces.com/contest/399/problem/A 解题思路: 构造出来即可,考虑p-k和p+k两个边界分别于1和n作比较,对左右符号特殊处理。 完整代码: #include <algorithm>#include <iostream>#include <cstring>#include <complex>#include